{-# LANGUAGE DeriveDataTypeable #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
module Bottom
( BottomId
, initialBottomId
) where

import Data.Word
import Format
import Data.Binary

newtype BottomId = BottomId Word64
  deriving(Eq, Ord, Show, Read, Enum)

initialBottomId :: BottomId
initialBottomId = BottomId 0

instance Format BottomId where
  format (BottomId wid) = show wid

instance Binary Bottom.BottomId where
  put (BottomId a) = put a
  get = get >>= \a -> return (BottomId a)

